(require (only (lib "1.ss" "srfi") filter))

(define (numbers a b)
  (cond ((> a b) null)
        (else (cons a (numbers (add1 a) b)))))

(define (cross l1 l2)
  (if (null? l1)
      '()
      (append (map (lambda (x)
                     (cons (car l1) x))
                   l2)
              (cross (cdr l1) l2))))

(define (square n)
  (* n n))

(define (try-ptriplet sum)
  (define ab (filter (lambda (x)
                       (< (car x) (cdr x)))
                     (cross (numbers 1 sum)
                            (numbers 1 sum))))
  (define abc (map (lambda (x)
                     (let ((a (car x))
                           (b (cdr x)))
                       (list a b (- sum (+ a b)))))
                   ab))
  
  (define triplets (filter (lambda (x)
                             (let ((a (car x))
                                   (b (cadr x))
                                   (c (caddr x)))
                               (= (square c)
                                  (+ (square a)
                                     (square b)))))
                           abc))
  triplets)

(try-ptriplet 1000)